# -*- coding: utf-8 -*-
#
# OSCam Web Start Plugin
#
from twisted.web import resource, http  
from Plugins.Plugin import PluginDescriptor
from Components.config import config
from Components.Network import iNetworkInfo
import os, socket

oscam_plugin_version=0.4
oscam_plugin_string=_("OSCam Web Start Plugin Version %s") % oscam_plugin_version
oscam_support_string=_("Webinterface")
oscam_pid_string=_("pid")
oscam_port_string=_("port")
oscam_config_string=_("config dir")
oscam_stopped_string=_("inactive")
oscam_wiki="http://www.streamboard.tv/wiki/OSCam/en"
oscam_plugindir="/usr/lib/enigma2/python/Plugins/Extensions/OSCamWebStart"

oscam_header_string  =""
oscam_header_string +="<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\""
oscam_header_string +="\"http://www.w3.org/TR/html4/loose.dtd\">"
oscam_header_string +="<head><title>%s</title>" % oscam_plugin_string
oscam_header_string +="<link rel=\"shortcut icon\" type=\"/web-data/image/x-icon\" href=\"/web-data/img/favicon.ico\">"
oscam_header_string +="<meta content=\"text/html; charset=UTF-8\" http-equiv=\"content-type\">"
oscam_header_string +="</head><body bgcolor=\"white\">"
oscam_header_string +="<font face=\"Tahoma, Arial, Helvetica\" color=\"black\">"
oscam_header_string +="<font size=\"4\" color=\"black\">"

if not os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/img/OSCam.png"):
	os.symlink("/usr/lib/enigma2/python/Plugins/Extensions/OSCamWebStart/OSCam.png","/usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/img/OSCam.png")

def sessionstart(reason, **kwargs):                                               
        if reason == 0 and "session" in kwargs:                                                        
		if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/WebInterface/WebChilds/Toplevel.py"):
                       	from Plugins.Extensions.WebInterface.WebChilds.Toplevel import addExternalChild
                       	addExternalChild( ("oscamwebstart", OSCamWebStart(), "OSCam Web Start", "1", True) )          
                else:                                                                                  
			print "[OSCamWebStart] DreamOS Webif not found"

def Plugins(**kwargs):
       		return [PluginDescriptor(where=PluginDescriptor.WHERE_SESSIONSTART, fnc=sessionstart, needsRestart=False)]

class OSCamWebStart(resource.Resource):

	def render_GET(self, req):
		pid=0
		if os.path.exists("/tmp/.oscam/oscam.pid"):
			p=open("/tmp/.oscam/oscam.pid","r")
			pid=p.readline()
			p.close()
			pid=pid.lstrip().rstrip()
			print "[OSCamWebStart] pid %s" % (pid)
		port=0
		support="unknown"
		config_dir="unknown"
		if os.path.exists("/tmp/.oscam/oscam.version"):
			o=open("/tmp/.oscam/oscam.version","r")
			line=o.readline()
			while line:
				line=o.readline()
				if line.startswith("WebifPort:"):
					part=[]
					part=line.split(":")
					port=int(part[1])
				if line.startswith("Web interface support:"):
					part=[]
					part=line.split(":")
					support=part[1].lstrip().rstrip()
				if line.startswith("ConfigDir:"):
					part=[]
					part=line.split(":")
					config_dir=part[1].lstrip().rstrip()
			o.close()
		print "[OSCamWebStart] port %d webif support %s config dir %s" % (port,support,config_dir)
		user="unknown"
		passwd="unknown"
		if os.path.exists("%s/oscam.conf" % config_dir):
			c=open("%s/oscam.conf" % config_dir,"r")
			line=c.readline()
			while line:
				line=c.readline()
				if line.startswith("httpuser"):
					part=[]
					part=line.split("=")
					user=part[1].lstrip().rstrip()
				if line.startswith("httppwd"):
					part=[]
					part=line.split("=")
					passwd=part[1].lstrip().rstrip()
			c.close()
		print "[OSCamWebStart] user %s passwd %s" % (user,passwd)

		ifaces = iNetworkInfo.getConfiguredInterfaces()         
		ip=None
                for iface in ifaces.itervalues():
                	ip = iface.getIpv4()
                        if not ip:
                 	       ip = iface.getIpv6()
		if ip is None:
			lip="localhost"
		else:
			lip=ip.getAddress()

		print "[OSCamWebStart] local ip %s" % (lip)
		oscam_webif="http://%s:%s" % (lip,port)
		oscam_landing  =""
		oscam_landing += oscam_header_string
		oscam_landing += "<br>%s<br><hr>" % oscam_plugin_string
		oscam_landing +="<img src=\"/web-data/img/OSCam.png\" alt=\"%s ...\"/><br>" % (oscam_plugin_string)
		oscam_landing +="<hr><form action=\"%s\">" % oscam_wiki
		oscam_landing +="<input type=\"submit\" size=\"100px\" title=\"%s\" value=\"%s\">" % ("Wiki","Wiki")
		oscam_landing +="</form>"                        
		if support == "yes" and pid > 0:
			oscam_landing +="<br><form action=\"%s\">" % oscam_webif
			oscam_landing +="<input type=\"submit\" size=\"100px\" title=\"%s\" value=\"%s\">" % ("Webif","Webif")
			oscam_landing +="</form>"                        
		oscam_landing += "<hr>%s: %s<br>" % (oscam_support_string,support)
		oscam_landing += "<br>%s: %s<br>" % (oscam_config_string,config_dir)
		if pid > 0:
			oscam_landing += "<br>%s: %s<br>" % (oscam_pid_string,pid)
			oscam_landing += "<br>%s: %s<hr>" % (oscam_port_string,port)
		else:
			oscam_landing += "<br>%s: %s (%s)<br>" % (oscam_pid_string,pid,oscam_stopped_string)

		req.setResponseCode(http.OK)
		req.setHeader('Content-type', 'text/html')
		req.setHeader('charset', 'UTF-8')
		return oscam_landing
